/*
 *  eXist Open Source Native XML Database
 *  Copyright (C) 2001-06 Wolfgang M. Meier
 *  wolfgang@exist-db.org
 *  http://exist.sourceforge.net
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *  
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *  
 *  $Id: TermMatcher.java 4403 2006-09-27 12:27:37Z wolfgang_m $
 */
package org.exist.storage;


/**
 * Implementations of this interface can be passed to method
* {@link org.exist.storage.TextSearchEngine#getNodes(XQueryContext, DocumentSet, NodeSet, TermMatcher, CharSequence)} 
 * to check if an index entry matches a given search term.
 * 
 * @author Wolfgang Meier (wolfgang@exist-db.org)
 */
public interface TermMatcher {
	
	public boolean matches(CharSequence term);
	
}
