/*
 *  eXist Open Source Native XML Database
 *  Copyright (C) 2001-04 The eXist Project
 *  http://exist-db.org
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  $Id: ApacheXmlComponentsTest.java 4197 2006-08-28 11:04:34Z wolfgang_m $
 */

package org.exist.validation.test;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.exist.validation.XmlLibraryChecker;

/**
 *  Class for testing XML Parser and XML Transformer configuration.
 *
 * @author dizzzz
 */
public class ApacheXmlComponentsTest extends TestCase {  
        
    public ApacheXmlComponentsTest(String testName) {
        super(testName);
    }
    
    public static Test suite() {
        TestSuite suite = new TestSuite(ApacheXmlComponentsTest.class);
        
        return suite;
    }
    
    protected void tearDown() {       
        System.out.println("tearDown");
    }
    
    protected void setUp() {      
        System.out.println("setUp");
    }
    
    
    public void testParserVersion()
    {
    	StringBuffer xmlLibMessage = new StringBuffer();
    	
    	boolean validParser = XmlLibraryChecker.hasValidParser(xmlLibMessage);
    	
    	assertTrue(xmlLibMessage.toString(), validParser);
    }
    
    public void testTransformerVersion()
    {
    	StringBuffer xmlLibMessage = new StringBuffer();
    	
    	boolean validTransformer = XmlLibraryChecker.hasValidTransformer(xmlLibMessage);
    	
    	assertTrue(xmlLibMessage.toString(), validTransformer);
    }
}
